#include "realtime_wrapper.h"

#include <string.h>
#include <sys/time.h>
#include "rt_test_actor.h"
#include "rttest_rtsleep.h"

namespace demo{
    CRTTestRTSleep* CRTTestRTSleep::m_pInstance = NULL;
    CRTTestRTSleep* CRTTestRTSleep::GetInstance() {
        if( NULL == m_pInstance ) {
            m_pInstance = new CRTTestRTSleep();
        }
        return m_pInstance;
    }

    CRTTestRTSleep::CRTTestRTSleep() : g_iRTThreadNum(0), g_ulRTThreadSleepTime(0) {
        for (int32_t iLoop=0; iLoop<RTTEST_RT_THREAD_MAX_NUM; iLoop++ ) {
            g_pRTTestActor[iLoop] = NULL;
        }
    }

    CRTTestRTSleep::~CRTTestRTSleep() {
        Done();
    }

    int32_t CRTTestRTSleep::Run() {
        int32_t iCPU = 2; 
        int32_t iPriority = 90;
        int32_t iStartTime = 3000;
        int32_t iTemp =0;

        g_iRTThreadNum = 15;
        g_ulRTThreadSleepTime = 80000;

        rtwrapper::rt_init_proc();

        Done();

        for (int32_t iLoop=0; iLoop<g_iRTThreadNum; iLoop++) {
            usleep(iStartTime * 1000);

            char strTmp[128] = "";
            memset(strTmp, 0, sizeof(strTmp));
            sprintf(strTmp, "RTTestActor%d_%d_%d", iLoop, iCPU, iPriority);
            g_pRTTestActor[iLoop] = new RTTestActor(strTmp, iPriority, iCPU);
            g_pRTTestActor[iLoop]->SetSleepTime(g_ulRTThreadSleepTime);
            g_pRTTestActor[iLoop]->SetWorkTime(iTemp);

            if (!g_pRTTestActor[iLoop]->Start()) {
                printf("Start Actor[%s] Failed!\r\n", strTmp);
                delete g_pRTTestActor[iLoop];
                g_pRTTestActor[iLoop] = NULL;
                continue;
            }
        }
        return 0;
    }

    int32_t CRTTestRTSleep::Done() {
        for (int32_t iLoop=0; iLoop<g_iRTThreadNum; iLoop++ ) {
            if (NULL != g_pRTTestActor[iLoop]) {
                g_pRTTestActor[iLoop]->Shutdown();
                delete g_pRTTestActor[iLoop];
                g_pRTTestActor[iLoop] = NULL;
            }
        }
        return 0;
    }

}
