#ifndef REALTIME_ADV_WRAPPER_H_
#define REALTIME_ADV_WRAPPER_H_

#include "realtime_wrapper.h"

namespace rtwrapper {
    ;
    class RTTask {
    public:
        static bool Sleep(int64_t us);
        RTTask();
        virtual ~RTTask();

        virtual bool Create(const char *name, int prio, int cpus[]); // cpus: end by -1, such as [0, 1, -1]
        virtual bool Close();
        bool IsValid() const;
        bool IsStart() const { return _start; }
        int GetLastErr() const { return _errno; }
    protected:
        bool Join(); // gently wait until task exit
        bool Kill(); // force kill task
        virtual void Process() = 0;
        RT_TASK_W _task;
    private:
        static void _Process(void *param);
        bool _ok;
        bool _start;
        int _errno;
    };

    class RTActor : public RTTask{
    public:
        RTActor(const char *name, int prio, int cpu);
        RTActor(const char *name, int prio, int cpus[]); // cpus: end by -1, such as [0, 1, -1]
        virtual ~RTActor();

        virtual bool Start();
        virtual void Shutdown();
        virtual void Run() = 0;

    public:
        static const int MAX_CPU = 32;

    protected:
        void Process();
        RTActor();

    private:
        bool _shutdown;
        bool _done;
        int _prio;
        int _cpus[MAX_CPU];
        char _name[32];
    };
}

#endif //REALTIME_ADV_WRAPPER_H_
