#ifndef REALTIME_WRAPPER_H_
#define REALTIME_WRAPPER_H_
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdint.h>
#include <sched.h>
#include <stddef.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <alchemy/task.h>

namespace rtwrapper {
    ;
    extern "C" {
        bool rt_init_proc();
    }

    typedef unsigned long long RTIME_W;
    typedef long long SRTIME_W;

    const RTIME_W TM_INFINITE_W = 0;
    const RTIME_W TM_NOW_W = 0;
    const RTIME_W TM_NONBLOCK_W = ((RTIME_W)-1ULL);
    extern "C" {
        RTIME_W rt_timer_read_w(void);
    }

    const int T_WARNSW_W = (1 << 1);

    const int T_JOINABLE_W = T_JOINABLE;
    const int T_FPU_W = 0;

    typedef struct RT_TASK  RT_TASK_W;

    typedef RT_TASK_INFO  RT_TASK_INFO_W;

    extern "C" {
        bool is_rt_task();
        int rt_task_create_w(RT_TASK_W *task, const char *name, int stksize, int prio, int mode, int cpus[]);
        int rt_task_delete_w(RT_TASK_W *task);
        int rt_task_set_affinity_w(RT_TASK_W *task, const cpu_set_t *cpus);
        int rt_task_start_w(RT_TASK_W *task, void (*entry)(void *arg), void *arg);
        int rt_task_join_w(RT_TASK_W *task);
        int rt_task_sleep_w(RTIME_W delay);
        RT_TASK_W *rt_task_self_w(void);
    }
}

#endif //REALTIME_WRAPPER_H_
